unit server;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,orb,orb_int,calendar,calendar_int;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Addr: TEdit;
    RunBtn: TButton;
    Memo1: TMemo;
    Label2: TLabel;
    PathEdit: TEdit;
    procedure RunBtnClick(Sender: TObject);
  protected
    procedure wndproc(var Message: TMessage); override;
  public
    dorb: IORB;
    df : IDate_init;
  end;

  TORBThread = class(TThread)
  private
    dorb: IORB;
  protected
    procedure execute; override;
  public
    constructor Create(orb: IORB);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  utils,poa_impl,poa_int,policy_int,types,calendar_impl;

procedure TForm1.wndproc(var Message: TMessage);
begin
  if message.Msg = CALENDAR_MESSAGE then
    begin
      Memo1.Lines.Add(PChar(message.WParam));
      FreeMem(PChar(message.WParam));
      message.Result := 1;
    end;
  inherited;
end;

procedure TForm1.RunBtnClick(Sender: TObject);
var
  params: TStrings;
  obj : IORBObject;
  p: IPOA;
  pm : IPOAManager;
  lst: PolicyList;
  id : ObjectID;
  impl : TCalendar_impl;
begin
  params := TStringList.Create;
  try
    params.Add('-ORBIIOPAddr');
    params.Add(addr.Text);
    dorb := ORB_Init(params);
    df := TDate_factory.Create();
    dorb.register_value_factory('IDL:date:1.0',df);
    obj := dorb.resolve_initial_reference('RootPOA');
    p := TPOA_impl._narrow(obj);
    setlength(lst,0);
    p := p.create_POA('calendar',p.the_POAManager,lst);
    pm := p.the_POAManager();
    impl := TCalendar_impl.Create(self.Handle);
    id := p.activate_object(impl);
    obj := p.id_to_reference(id);
    params.clear;
    params.add(dorb.object_to_string(obj));
    params.SaveToFile(PathEdit.Text);
    pm.activate;
    TORBThread.Create(dorb);
    RunBtn.Enabled := false;
  finally
    params.Free;
  end;
end;

{ TORBThread }

constructor TORBThread.Create(orb: IORB);
begin
  dorb := orb;
  inherited Create(false);
  FreeOnTerminate := true;
end;

procedure TORBThread.execute;
begin
  dorb.run;
end;

end.
